// ModExLowVC6.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "..\..\Engine\External\ExtTypesVC.h"
#include <string.h>
#include <stdlib.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    
    return TRUE;
}


extern "C" {


// return number of modules in this library
__declspec(dllexport) void __cdecl ModuleCount(int &Count)
{
  Count = 1;
}


// return info about module
__declspec(dllexport) void __cdecl ModuleInfo(int Index, TModuleInfo &Info)
{
  strcpy(Info.Name, "Not Ext VC6 Module");
  strcpy(Info.Description, "Negates given memory");
  strcpy(Info.LibName, "ModExLowVC6");
  strcpy(Info.Creator, "Uzbek Zauder, Zampyre ClockWorks");
  strcpy(Info.Language, "Visual C++ 6");
  strcpy(Info.IDCode, "CMP-NOT");
  Info.Platform = pfIndependent;
  Info.Version.Version = 0x01020304;
  Info.Style = msLowLevel;
  Info.RequiresLib = false;
}



bool __cdecl CompressBuffer(void * InData, int InSize,  void * &OutData,  int &OutSize)
{
  if ((InData == NULL) || (InSize == 0))
    return false;

  OutSize = InSize;
  OutData = malloc(OutSize);

  for (int I = 0; I < InSize; I++)
  {
    *((char*)OutData + I) = *((char*)InData + I); 
  }

  return true;
}


bool __cdecl DecompressBuffer(void * InData, int InSize,  void * &OutData,  int &OutSize)
{
  return CompressBuffer(InData, InSize, OutData, OutSize);
}


static TExtCompressInfo Ext;


// return module's extended info
__declspec(dllexport) void __cdecl ModuleExtInfo(int Index, void * &ExtInfo)
{
  Ext.CanCompress = true;
  Ext.CanDecompress = true;
  Ext.CompressBuffer = CompressBuffer;
  Ext.DecompressBuffer = DecompressBuffer;

  ExtInfo = &Ext;
}

} // extern "C"